"use strict";var __importDefault=this&&this.__importDefault||function(e){return e&&e.__esModule?e:{default:e}};Object.defineProperty(exports,"__esModule",{value:!0}),exports.AbstractGenerateCangjieResource=void 0;const path_1=__importDefault(require("path")),fs_1=__importDefault(require("fs")),file_util_1=require("@ohos/hvigor-ohos-plugin/src/utils/file-util"),build_directory_const_1=require("@ohos/hvigor-ohos-plugin/src/const/build-directory-const"),base_cangjie_task_1=require("./base-cangjie-task"),hvigor_1=require("@ohos/hvigor"),constants_1=require("../constants/constants"),common_const_1=require("@ohos/hvigor-ohos-plugin/src/const/common-const"),common_utils_1=require("../utils/common-utils"),cangjie_file_util_1=require("../utils/cangjie-file-util"),ohos_logger_1=require("@ohos/hvigor-ohos-plugin/src/utils/log/ohos-logger"),toml_export_1=require("../utils/toml/toml-export");class AbstractGenerateCangjieResource extends base_cangjie_task_1.BaseCangjieTask{constructor(e,t){super(e,t),this.ohosLogger=ohos_logger_1.OhosLogger.getLogger(AbstractGenerateCangjieResource.name),this.resPath=path_1.default.resolve(this.service.getModuleModel().getProjectDir(),(0,cangjie_file_util_1.cangjieSrcRelatePath)(),"cj_res"),this.resSrcPath=path_1.default.resolve(this.resPath,"src"),this.appResPath=path_1.default.resolve(this.resSrcPath,"AppR.cj"),this.sysResPath=path_1.default.resolve(this.resSrcPath,"SysR.cj"),this.resTomlPath=path_1.default.resolve(this.resPath,constants_1.CJPM_TOML_NAME)}declareInputFiles(){var e;return this.initCangjieSdk(),(new hvigor_1.FileSet).addEntries([this.getResourceTableTxt(this.targetData),void 0===(null===(e=this.sdkCangjieComponent)||void 0===e?void 0:e.sysResourcePath)?"":this.sdkCangjieComponent.sysResourcePath,path_1.default.resolve(this.moduleModel.getProjectDir(),"src","main","module.json5"),path_1.default.resolve(this.moduleModel.getProjectDir(),"oh-package.json5"),this.cjpmTomlPath],{isDirectory:!1})}declareOutputFiles(){return(new hvigor_1.FileSet).addEntries([this.appResPath,this.sysResPath,this.resTomlPath],{isDirectory:!1})}doTaskAction(){if(!fs_1.default.existsSync(constants_1.CJPM_TOML_PATH))return;const e=fs_1.default.readFileSync(constants_1.CJPM_TOML_PATH,"utf8");let t={};const s=new toml_export_1.TOML;try{t=s.parse(e)}catch(e){return void this.ohosLogger.debug(e)}if(this.writeAppResource(t),this.writeSysResource(),this.generateToml(s,t),(0,cangjie_file_util_1.onlyCangjieModule)(this.moduleModel.getProjectDir())){const e=this.readTomlName();this.generateAbilityStageRegisters(e),this.generateAbilityRegisters(e)}}writeSysResource(){if(void 0===this.sdkCangjieComponent||!fs_1.default.existsSync(this.sdkCangjieComponent.sysResourcePath))return;file_util_1.FileUtil.checkDirWithoutDelete(this.resSrcPath);let e=fs_1.default.readFileSync(this.sdkCangjieComponent.sysResourcePath,"utf-8");const t=fs_1.default.openSync(this.sysResPath,"w+");fs_1.default.writeFileSync(t,`package cj_res_${this.moduleName}\n\n`),e.startsWith("package cj_res")&&(e=e.substring(14)),fs_1.default.writeFileSync(t,e),fs_1.default.close(t)}parseResource(e,t){var s;for(const i of e){const[e,r,o]=i.split(" ");t.has(e)?null===(s=t.get(e))||void 0===s||s.set(r,Number(o)):t.set(e,(new Map).set(r,Number(o)))}}writeAppResource(e){const t=[],s=new Map,i=this.getResourceTableTxt(this.targetData);file_util_1.FileUtil.checkDirWithoutDelete(this.resSrcPath);const r=fs_1.default.readFileSync(i,"utf-8");t.push(...r.trim().split("\n")),this.parseResource(t,s),file_util_1.FileUtil.checkFile(this.appResPath);const{declareRes:o,appRes:a,updateHarRes:n,updateAllRes:l}=this.generateResContent(s,e),c=fs_1.default.openSync(this.appResPath,"w+");fs_1.default.writeFileSync(c,o),fs_1.default.writeFileSync(c,a),this.moduleModel.isHarModule()&&fs_1.default.writeFileSync(c,n),this.isDependHarModule()&&this.service.getHarDependencies().length>0&&fs_1.default.writeFileSync(c,l),fs_1.default.close(c)}generateResContent(e,t){let s="public func updateAllRes() {\n\tlet resourceMap: HashMap<String, Int64> = HashMap<String, Int64>()\n",i="",r=`public func update${this.moduleName}Res(resourceMap: HashMap<String, Int64>) {\n`;e.forEach(((e,t)=>{const o=t.slice(0,1).toUpperCase()+t.slice(1);i+=`public class App${o} {\n`,e.forEach(((e,o)=>{i+=`\tpublic var ${o} = ${e}\n`,s+=`\tresourceMap.put("${t} ${o}", ${e})\n`,r+=`\tapp.${t}.${o} = resourceMap["${t} ${o}"]\n`})),i+="}\n\n"})),r+="}\n\n",i+="public class app {\n",e.forEach(((e,t)=>{const s=t.slice(0,1).toUpperCase()+t.slice(1);i+=`\tpublic static let ${t} = App${s}()\n`})),i+="}\n\n";let o=`package cj_res_${this.moduleName}\n\n`;const a=this.service.getHarDependencies(),n=hvigor_1.hvigorCore.getProject();if((0,cangjie_file_util_1.onlyCangjieModule)(this.moduleModel.getProjectDir())&&this.isDependHarModule()&&a.length>0&&void 0!==n){const e=this.service.getHarModuleDependencyPaths();a.forEach((i=>{if(this.getDependResPath(n,e,i,t,!1)){const e=i.getPackageName();o+=`import cj_res_${e}.update${e}Res\n`,s+=`\tupdate${e}Res(resourceMap)\n`}}))}return(this.moduleModel.isHarModule()||this.isDependHarModule()&&a.length>0)&&(o+="import std.collection.*\n\n"),s+="}\n\n",s+="let updateRes = updateAllRes()\n\n",{declareRes:o,appRes:i,updateHarRes:r,updateAllRes:s}}getResourceTableTxt(e){return path_1.default.resolve(e.getPathInfo().getIntermediatesRes(),build_directory_const_1.BuildArtifactConst.RESOURCE_TABLE_TXT)}generateToml(e,t){t[constants_1.PACKAGE][constants_1.NAME]=`cj_res_${this.moduleName}`,this.getAllHarCjLibs(t),this.getAllPreviewRes(t),file_util_1.FileUtil.checkDirWithoutDelete(this.resPath),fs_1.default.writeFileSync(this.resTomlPath,e.stringify(t))}isDependHarModule(){return!(this.moduleModel.isHarModule()&&this.targetService.getTargetData().getTargetName()!==common_const_1.DefaultTargetConst.OHOS_TEST_TARGET)}generateAbilityRegisters(e){const t=this.targetService.getTargetData().getModuleSourceSetModel().getModuleTargetRes().getModuleJsonOpt().module.abilities;let s=`package ${e}\n\n`;s+="import ohos.ability.Ability\n";let i="";null==t||t.forEach((t=>{const r=t.name,o=t.srcEntry;if(void 0!==o&&common_const_1.ValidateRegExp.STARTUP_TASK_SRC_ENTRY_REG_EXP.test(path_1.default.extname(o)))return;if(void 0===o||""===o||!constants_1.CJ_ABILITY_NAME_REG.test(o)||o.endsWith(".cj"))return void this.ohosLogger._buildError(`Abilities-srcEntry '${o}' is incorrect.`)._detail("In cangjie application, the abilities srcEntry format should be packageName.AbilityClassName. for example, ohos_app_cangjie_entry.MainAbility")._file(path_1.default.resolve(this.moduleModel.getProjectDir(),"src","main","module.json5"))._printErrorAndExit();o.startsWith(`${e}.`)&&-1===(null==o?void 0:o.substring(e.length+1).indexOf("."))||(s+=`import ${o}\n`);const a=o.substring(o.lastIndexOf(".")+1);i+=`let ${r.toUpperCase()}_REGISTER_RESULT = Ability.registerCreator("${r}", {=> ${a}()})\n`})),(0,common_utils_1.checkIsValid)(s)&&(i=`${s}\n${i}`);const r=path_1.default.resolve(this.service.getModuleModel().getProjectDir(),(0,cangjie_file_util_1.cangjieSrcRelatePath)(),"src"),o=path_1.default.join(r,"ability_mainability_entry.cj");(0,common_utils_1.checkIsValid)(i)?((0,cangjie_file_util_1.createDir)(r),fs_1.default.writeFileSync(o,i)):fs_1.default.existsSync(o)&&fs_1.default.unlinkSync(o)}generateAbilityStageRegisters(e){const t=this.targetService.getTargetData().getModuleSourceSetModel().getModuleTargetRes().getModuleJsonOpt().module,s=t.name,i=t.srcEntry;if(!this.moduleModel.isHapModule()&&!(0,common_utils_1.checkIsValid)(i))return;if(void 0!==i&&common_const_1.ValidateRegExp.STARTUP_TASK_SRC_ENTRY_REG_EXP.test(path_1.default.extname(i)))return;if(void 0===i||""===i||!constants_1.CJ_ABILITY_NAME_REG.test(i)||i.endsWith(".cj")){const e=void 0===i?"Missing required property 'module-srcEntry' .":`Module-srcEntry '${i}' is incorrect.`;return void this.ohosLogger._buildError(e)._detail("In cangjie application, the module srcEntry format should be packageName.AbilityStageClassName. for example, ohos_app_cangjie_entry.MyAbilityStage")._file(path_1.default.resolve(this.moduleModel.getProjectDir(),"src","main","module.json5"))._printErrorAndExit()}let r=`package ${e}\n\n`;i.startsWith(`${e}.`)&&-1===(null==i?void 0:i.substring(e.length+1).indexOf("."))||(r+=`import ${i}\n`),r+="import ohos.ability.AbilityStage\n\n";const o=i.substring(i.lastIndexOf(".")+1);r+=`let ${s.toUpperCase()}_STAGE_REGISTER_RESULT = AbilityStage.registerCreator("${s}", {=> ${o}()})\n`;const a=path_1.default.resolve(this.service.getModuleModel().getProjectDir(),(0,cangjie_file_util_1.cangjieSrcRelatePath)(),"src"),n=path_1.default.join(a,`module_${this.moduleName}_entry.cj`);(0,common_utils_1.checkIsValid)(r)?((0,cangjie_file_util_1.createDir)(a),fs_1.default.writeFileSync(n,r)):fs_1.default.existsSync(n)&&fs_1.default.unlinkSync(n)}getDependHarPaths(e){const t=hvigor_1.hvigorCore.getProject();if(!this.isDependHarModule()||!(0,cangjie_file_util_1.onlyCangjieModule)(this.moduleModel.getProjectDir())||void 0===t)return;const s=this.service.getHarModuleDependencyPaths();this.service.getHarDependencies().forEach((i=>{this.getDependResPath(t,s,i,e,!0)}))}readTomlName(){const e=fs_1.default.readFileSync(this.cjpmTomlPath,"utf8");let t={};try{const s=(0,common_utils_1.replaceWithEnv)(e);t=(new toml_export_1.TOML).parse(s)}catch(e){const t=(0,common_utils_1.checkIsValid)(e.errorCodeBlock)?e.errorCodeBlock:"";this.ohosLogger._buildError(`Invalid TOML Config\n${t}`)._file(`${this.cjpmTomlPath}:${e.errorLine}:${e.errorColumn}`)._printErrorAndExit()}const s=t[constants_1.PACKAGE][constants_1.NAME];return(0,common_utils_1.checkIsValid)(s)||this.ohosLogger._buildError(`Invalid TOML Config\n ${constants_1.PACKAGE}.${constants_1.NAME} is invalid`)._file(`${this.cjpmTomlPath}`)._printErrorAndExit(),s}}exports.AbstractGenerateCangjieResource=AbstractGenerateCangjieResource;